unit pref;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ComCtrls, StdCtrls, ExtCtrls, registry, activex, shlobj, comobj,
  Mask, ToolEdit, CheckLst;

type
  Tf_pref = class(TForm)
    pc_pref: TPageControl;
    sb_close: TSpeedButton;
    ts_printer: TTabSheet;
    ts_palette: TTabSheet;
    ts_ftypes: TTabSheet;
    ts_short: TTabSheet;
    tb_hscale: TTrackBar;
    la_hscale: TLabel;
    la_vscale: TLabel;
    tb_vscale: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    tb_tmargin: TTrackBar;
    tb_vmargin: TTrackBar;
    la_tmargin: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    la_vmargin: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    sb_pfolder: TSpeedButton;
    sb_psdialog: TSpeedButton;
    dlg_psetup: TPrinterSetupDialog;
    lb_colors: TListBox;
    sh_sample: TShape;
    sb_pickcolor: TSpeedButton;
    sb_apply: TSpeedButton;
    sb_restore: TSpeedButton;
    dlg_pickcolor: TColorDialog;
    Label5: TLabel;
    cb_userdefext: TCheckBox;
    e_userdefext: TEdit;
    Label8: TLabel;
    sb_register: TSpeedButton;
    cb_cdsk: TCheckBox;
    Label11: TLabel;
    cb_csm: TCheckBox;
    cb_cpg: TCheckBox;
    sb_ress: TSpeedButton;
    ts_misc: TTabSheet;
    cb_scan: TCheckBox;
    cb_gs: TCheckBox;
    cb_center: TCheckBox;
    Label12: TLabel;
    cb_acceptall: TCheckBox;
    cb_defaultview: TCheckBox;
    de_favor: TDirectoryEdit;
    cb_start: TCheckBox;
    clb_ftypes: TCheckListBox;
    cb_ex_as_chunx: TCheckBox;
    cb_savesl: TCheckBox;
    procedure sb_closeClick(Sender: TObject);
    procedure sb_psdialogClick(Sender: TObject);
    procedure sb_pfolderClick(Sender: TObject);
    procedure sb_pickcolorClick(Sender: TObject);
    procedure lb_colorsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sb_restoreClick(Sender: TObject);
    procedure sb_applyClick(Sender: TObject);
    procedure tb_hscaleChange(Sender: TObject);
    procedure tb_vscaleChange(Sender: TObject);
    procedure tb_tmarginChange(Sender: TObject);
    procedure tb_vmarginChange(Sender: TObject);
    procedure cb_userdefextClick(Sender: TObject);
    procedure sb_registerClick(Sender: TObject);
    procedure sb_ressClick(Sender: TObject);
    procedure de_favorChange(Sender: TObject);
    procedure cb_sClick(Sender: TObject);
    procedure de_favorExit(Sender: TObject);
    procedure cb_trdClick(Sender: TObject);
    procedure cb_shwClick(Sender: TObject);
  private
    { Private declarations }
    procedure check_all;
  public
    procedure makelink(desktop: boolean; mfolder: boolean; folder, symlink, filename: string);
    { Public declarations }
  end;

var
  f_pref: Tf_pref;

implementation

uses FmxUtils, constants, main, reguse, full;

{$R *.DFM}

procedure tf_pref.makelink(desktop: boolean; mfolder: boolean; folder, symlink, filename: string);
var
   myobject  : iunknown;
   mysLink   : ishelllink;
   mypfile   : ipersistfile;
   directory : string;
   wfileName : widestring;
   myreg     : treginifile;
begin
     {$I-}
     myobject := createcomobject(CLSID_ShellLink);
     myslink := myObject as ishelllink;
     mypfile := myObject as ipersistfile;
     MyReg := TRegIniFile.Create(
         'Software\MicroSoft\Windows\CurrentVersion\Explorer');

   if desktop then directory := myreg.readstring('Shell Folders','Desktop','')
   else directory := myreg.readstring('Shell Folders','Programs','');

   if mfolder then mkdir(directory+'\'+folder)
   else begin
    with myslink do begin
     setarguments('');
     setpath(pchar(extractfilepath(paramstr(0))+filename));
     setworkingdirectory(pchar(extractfilepath(paramstr(0))));
    end;
    wfilename := directory+'\'+folder+'\'+symlink+'.lnk';
    mypfile.save(pwchar(wfilename),false);
   end;
   myreg.free;
end;


procedure Tf_pref.sb_closeClick(Sender: TObject);
begin
     f_pref.close;
end;

procedure Tf_pref.sb_psdialogClick(Sender: TObject);
begin
     dlg_psetup.execute;
end;

procedure Tf_pref.sb_pfolderClick(Sender: TObject);
begin
     executefile('rundll32.exe', 'shell32.dll,Control_RunDLL main.cpl @2','',SW_SHOW);
end;

procedure Tf_pref.sb_pickcolorClick(Sender: TObject);
begin
     dlg_pickcolor.color:= sh_sample.brush.color;
     if dlg_pickcolor.execute then sh_sample.brush.color:= dlg_pickcolor.color;
end;

procedure Tf_pref.lb_colorsClick(Sender: TObject);
begin
     sh_sample.brush.color:= spec_colors[lb_colors.itemindex+1];
end;

procedure Tf_pref.FormCreate(Sender: TObject);
var
   a,
   c    : integer;
   lkey : string;
   i    : byte;
begin
      if paramcount = 1 then
      if lowercase(paramstr(1)) = '--safe' then exit;


     lkey:= 'Software\HA\SpecView SE';
     if read_reg(HKEY_CURRENT_USER, lkey, 'FirstTime') = '0' then begin
      val(read_reg(HKEY_CURRENT_USER, lkey, 'HScale'), a, c);
      f_pref.tb_hscale.position:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'VScale'), a, c);
      f_pref.tb_vscale.position:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'VMargin'), a, c);
      f_pref.tb_vmargin.position:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'TMargin'), a, c);
      f_pref.tb_tmargin.position:= a;

      for i:= 0 to 7 do
       if read_reg(HKEY_CURRENT_USER, lkey, keyz[i+1]) = '1'
       then clb_ftypes.checked[i]:= true;

      if read_reg(HKEY_CURRENT_USER, lkey, 'ExtUSER') = '1' then begin
       f_pref.cb_userdefext.checked:= true;
       f_pref.e_userdefext.enabled:= true;
      end;


      if read_reg(HKEY_CURRENT_USER, lkey, 'DesktopIcon') = '1' then
      f_pref.cb_cdsk.checked:= true;
      if read_reg(HKEY_CURRENT_USER, lkey, 'ProgramGroup') = '1' then
      f_pref.cb_cpg.checked:= true;
      if read_reg(HKEY_CURRENT_USER, lkey, 'StartMenu') = '1' then
      f_pref.cb_csm.checked:= true;

      if read_reg(HKEY_CURRENT_USER, lkey, 'GrayScale') = '1' then
      f_pref.cb_gs.checked:= true;
      if read_reg(HKEY_CURRENT_USER, lkey, 'Center') = '1' then begin
       f_pref.cb_center.checked:= true;
       f_main.top:= abs(screen.height-f_main.height) div 2;
       f_main.left:= abs(screen.width-f_main.width) div 2;
      end;
      if read_reg(HKEY_CURRENT_USER, lkey, 'AcceptAll') = '1' then
      f_pref.cb_acceptall.checked:= true;

      if read_reg(HKEY_CURRENT_USER, lkey, 'StartAuto') = '1' then
      f_pref.cb_start.checked:= true;


      if read_reg(HKEY_CURRENT_USER, lkey, 'Rescan') = '1' then f_pref.cb_scan.checked:= true;
      de_favor.text:= read_reg(HKEY_CURRENT_USER, lkey, 'MRU');
      f_main.dlg_open.initialdir:= de_favor.text;
     end else de_favor.text:= extractfilepath(paramstr(0))+'screens\';

     lb_colors.itemindex:= 0;
     lb_colorsclick(sender);

     if paramcount<>0 then
      if (lowercase(extractfileext(paramstr(1))) <> '.shw') and (lowercase(extractfileext(paramstr(1))) <> '.trd') and (lowercase(extractfileext(paramstr(1))) <> '.scl') then begin
       f_main.pb_progress.position:= 0;
       de_favor.text:= extractfilepath(paramstr(1));
       container_size:= f_main.readfile(paramstr(1));
       if (container_size = 0) or (container_size > 6929) then
        messagebox(f_main.handle,
                   pchar(paramstr(1)+' - '+m_corr),
                   'SpecView SE',
                   MB_OK or MB_ICONERROR)
       else begin
        f_main.caption:= paramstr(1)+' - SpecView SE';
        application.title:= paramstr(1)+' - SpecView SE';
        f_main.makepic(container_size);
       end;
     end;


     // Scan directory at start-up
     if cb_scan.checked then begin
      f_main.tb_rescanClick(sender);
     end;

     if read_reg(HKEY_CURRENT_USER, lkey, 'CheckDefault') = '1'
     then cb_defaultview.checked:= true;

     if read_reg(HKEY_CURRENT_USER, lkey, 'ExportAsChunx') = '1'
     then cb_ex_as_chunx.checked:= true;

     if read_reg(HKEY_CURRENT_USER, lkey, 'SLSavePrompt') = '1'
     then cb_savesl.checked:= true;

     check_all;

     if cb_defaultview.checked and f_pref.cb_defaultview.enabled
     then sb_registerclick(sender);

end;

procedure Tf_pref.sb_restoreClick(Sender: TObject);
var
   i: byte;
begin
     if messagedlg('Do you want to restore default colors?',
                   mtwarning,
                   [mbyes, mbno], 0) = idyes then begin
      for i:= 1 to 15 do spec_colors[i]:= bak_colors[i];
      lb_colorsclick(sender);
      f_main.pb_progress.position:= 0;
      f_main.makepic(container_size);
     end;
end;

procedure Tf_pref.sb_applyClick(Sender: TObject);
begin
     f_main.pb_progress.position:= 0;
     spec_colors[lb_colors.itemindex+1]:= sh_sample.brush.color;
     f_main.makepic(container_size);
end;

procedure Tf_pref.tb_hscaleChange(Sender: TObject);
begin
     tb_hscale.hint:= '1:'+inttostr(tb_hscale.position);
end;

procedure Tf_pref.tb_vscaleChange(Sender: TObject);
begin
     tb_vscale.hint:= '1:'+inttostr(tb_vscale.position);
end;

procedure Tf_pref.tb_tmarginChange(Sender: TObject);
begin
     tb_tmargin.hint:= inttostr(tb_tmargin.position);
end;

procedure Tf_pref.tb_vmarginChange(Sender: TObject);
begin
     tb_vmargin.hint:= inttostr(tb_vmargin.position);
end;

procedure Tf_pref.cb_userdefextClick(Sender: TObject);
begin
     check_all;
     if cb_userdefext.checked then e_userdefext.enabled:= true
     else e_userdefext.enabled:= false;
end;

procedure go_register(extension: string);
begin
     wrt_reg(HKEY_CLASSES_ROOT, extension, '', k_name, true);
     wrt_reg(HKEY_CLASSES_ROOT, k_name, '', k_name, true);
     wrt_reg(HKEY_CLASSES_ROOT, k_name+'\DefaultIcon', '', paramstr(0), true);
     wrt_reg(HKEY_CLASSES_ROOT, k_name+'\shell\open\command', '', paramstr(0)+' "%1"', true);
end;

const
     typez     : array [1..8] of string=
                 ('.s', '.spc', '.$c', '.scr', '.bin', '.trd', '.shw', '.scl');

procedure Tf_pref.sb_registerClick(Sender: TObject);
var waschecked: boolean;
    s         : string;
    t         : integer;
    i         : byte;
begin
     waschecked:= false;
     t:= MB_OK or MB_ICONERROR;
     s:= 'None of the options were selected.';
     for i:= 0 to 7 do
      if clb_ftypes.checked[i] = true then begin
       go_register(typez[i+1]);
       waschecked:= true;
      end;
     if cb_userdefext.checked then begin
      go_register('.'+e_userdefext.text);
      waschecked:= true;
     end;
     if waschecked then begin
       s:= 'The file types you''ve selected were registered.';
       t:= MB_OK or MB_ICONINFORMATION;
     end;
     if (sender = sb_register) then
     messagebox(windowhandle,
                pchar(s),
                'SpecView SE',
                t);
end;

procedure Tf_pref.sb_ressClick(Sender: TObject);
var waschecked: boolean;
    s         : string;
    t         : integer;
begin
     waschecked:= false;
     t:= MB_OK or MB_ICONERROR;
     s:= 'None of the options were selected.';
     if cb_cdsk.checked then begin
      makelink(true, false, '', 'SpecView SE', paramstr(0));
      waschecked:= true;
     end;
     if cb_csm.checked then begin
      makelink(false, false, '', 'SpecView SE', paramstr(0));
      waschecked:= true;
     end;
     if cb_cpg.checked then begin
      makelink(false, true, 'SpecView SE', '', '');
      makelink(false, false, 'SpecView SE', 'SpecView SE', paramstr(0));
      makelink(false, false, 'SpecView SE', 'SpecView SE Readme', extractfilepath(paramstr(0))+'docs\readmain.html');
      makelink(false, false, 'SpecView SE', 'SpecView SE Home', extractfilepath(paramstr(0))+'web\ha.url');
      waschecked:= true;
     end;
      if waschecked then begin
       s:= 'The shortcuts you''ve selected were restored.';
       t:= MB_OK or MB_ICONINFORMATION;
      end;
     messagebox(windowhandle,
                pchar(s),
                'SpecView SE',
                t);
end;

procedure Tf_pref.de_favorChange(Sender: TObject);
var
   s : string;
begin
     s:= de_favor.text;
     if s[length(s)] <> '\' then s:= s+'\';
     de_favor.text:= s;
     f_main.dlg_open.initialdir:= de_favor.text;
end;

procedure Tf_pref.check_all;
var
   waschecked : boolean;
   i          : byte;
begin
     waschecked:= false;
     for i:= 0 to 7 do if clb_ftypes.checked[i] = true then waschecked:= true;
     if waschecked or cb_userdefext.checked then cb_defaultview.enabled:= true
     else cb_defaultview.enabled:= false;
end;

procedure Tf_pref.cb_sClick(Sender: TObject);
begin
     check_all;
end;

procedure Tf_pref.de_favorExit(Sender: TObject);
var
   s : string;
begin
        s:= de_favor.text;
        if s[length(s)] <> '\' then s:= s+'\';
        de_favor.text:= s;
end;

procedure Tf_pref.cb_trdClick(Sender: TObject);
begin
     check_all;
end;

procedure Tf_pref.cb_shwClick(Sender: TObject);
begin
     check_all;
end;

end.
